//
// C++ Implementation: bot
//
// Description: 
//
// Main bot file
//
// Author:  Rick <rickhelmus@gmail.com>, (C) 2004
//
//
//

#include "cube.h"

dvector bots;
CBotManager BotManager;

struct itemstat { int add, max, sound; };

extern bool intermission;
extern bool listenserv;
extern ENetHost *clienthost;
extern vector<server_entity> sents;
extern int triggertime;
extern itemstat itemstats[];
extern bool logbotinfo;

extern float rad(float x);
extern void normalise(dynent *m, float angle);
extern bool enemylos(dynent *m, vec &v);
extern void spawnstate(dynent *d);
extern void pickup(int n, dynent *d);

const vec g_vecZero = {0,0,0};

//Bot class begin

void CBot::Spawn()
{
	// Init all bot variabeles
	m_pMyEnt->eyeheight = 3.2f;
    	m_pMyEnt->aboveeye = 0.7f;
    	m_pMyEnt->radius = 1.1f;
    	
        spawnplayer(m_pMyEnt);
	
    	m_pMyEnt->targetyaw = m_pMyEnt->yaw = m_pMyEnt->targetpitch = m_pMyEnt->pitch = 0.0f;
    	m_pMyEnt->move = 0;
    	m_pMyEnt->enemy = player1;
    	m_pMyEnt->maxspeed = 22.0f;
    	m_pMyEnt->health = 100;
    	m_pMyEnt->armour = 50;
    	m_pMyEnt->pitch = 0;
    	m_pMyEnt->roll = 0;
    	m_pMyEnt->state = CS_ALIVE;
    	m_pMyEnt->anger = 0;
	m_pMyEnt->pBot = this;	
	loopi(NUMGUNS) m_pMyEnt->ammo[i] = 0;
	m_pMyEnt->ammo[GUN_FIST] = 1;
    	if(m_noitems)
    	{
        	m_pMyEnt->gunselect = GUN_RIFLE;
        	m_pMyEnt->armour = 0;
        	if(m_noitemsrail)
        	{
	        	m_pMyEnt->health = 1;
        	    	m_pMyEnt->ammo[GUN_RIFLE] = 100;
	        }
        	else
	        {
			if(gamemode==12) { m_pMyEnt->gunselect = GUN_FIST; return; };  // eihrul's secret "instafist" mode
            		m_pMyEnt->health = 256;
            		if(m_tarena)
            		{
                		int gun1 = rnd(4)+1;
                		botbaseammo(m_pMyEnt->gunselect = gun1, m_pMyEnt);
                		for(;;)
                		{
                    			int gun2 = rnd(4)+1;
                    			if(gun1!=gun2) { botbaseammo(gun2, m_pMyEnt); break; };
                		};
            		}
            		else if(m_arena)    // insta arena
            		{
                		m_pMyEnt->ammo[GUN_RIFLE] = 100;
            		}
            		else // efficiency
            		{
                		loopi(4) botbaseammo(i+1, m_pMyEnt);
                		m_pMyEnt->gunselect = GUN_CG;
            		};
            		m_pMyEnt->ammo[GUN_CG] /= 2;
        	};
    	}
    	else
    	{
        	m_pMyEnt->ammo[GUN_SG] = 5;
		SelectGun(GUN_SG);
    	};
		
	m_flShootDelay = m_flChangeWeaponDelay = 0.0f;
        m_iPauseDelay = m_iPauseTime = m_iCheckEnvDelay = 0;
        m_vPrevOrigin = g_vecZero;
        m_iStuckCheckDelay = lastmillis + 250;
        m_bStuck = false;
        m_iStuckTime = 0;
        m_iMoveDir = m_iStrafeDir = 0;
        m_iCombatNavTime = 0;
        
        m_iLastJumpPad = 0;
        m_pTargetEnt = NULL;
        m_iCheckTeleporterDelay = m_iCheckJumppadsDelay = 0;
        m_iCheckEntsDelay = 0;
        
        m_iAimDelay = 0;
}

void CBot::Think()
{
        if (intermission)
             return;
             
	// Bot is dead?
	if (m_pMyEnt->state == CS_DEAD)
	{
		if(lastmillis-m_pMyEnt->lastaction<1200)
		{
			m_pMyEnt->move = 0;
			moveplayer(m_pMyEnt, 1, false);
		}
		else if (!m_arena)
			Spawn();
	
		return;
	}
		
	CheckItems();
	CheckQuad(curtime);
	
        // Basic AI
        
        // Default bots will run forward
        m_pMyEnt->move = 1;
        
        // Default bots won't strafe
        m_pMyEnt->strafe = 0;
        
        if (!BotManager.BotsShoot() && m_pMyEnt->enemy)
             m_pMyEnt->enemy = NULL;
             
        // Find enemy
        if (BotManager.BotsShoot() && FindEnemy())
        {
             // Shoot at enemy
             ShootEnemy();
        }

        // Navigate        
        HomeThroughMap();
        
		
	// Aim to ideal yaw and pitch
	AimToIdeal();
	
        // Store current location, to see if the bot is stuck
        m_vPrevOrigin = m_pMyEnt->o;
        
	// Move the bot
	moveplayer(m_pMyEnt, 1, false);
	
	// Update bot info on all clients
	SendBotInfo();
}

dynent *CBot::CreateBot(const char *team, const char *name)
{
     dynent *m = newdynent();
     CBot *pBot = new CBot;
     m->bIsBot = true;
     pBot->m_pMyEnt = m;
     pBot->m_iLastBotUpdate = 0;
     pBot->m_bSendC2SInit = false;

     if (name && *name)
          strn0cpy(m->name, name, 16);
     else
          strn0cpy(m->name, BotManager.GetBotName(), 16);
     
     if (team && *team)
          strn0cpy(m->team, team, 5);
     else
          strn0cpy(m->team, BotManager.GetBotTeam(), 5);
    
     pBot->Spawn();
     bots.add(m);
     //particle_trail(1, 500, player1->o, m->o);
     return m;	
}

void CBot::AimToVec(const vec &o)
{
     m_pMyEnt->targetpitch = atan2(o.z-m_pMyEnt->o.z, GetDistance(o))*180/PI;
     m_pMyEnt->targetyaw = -(float)atan2(o.x - m_pMyEnt->o.x, o.y - m_pMyEnt->o.y)/PI*180+180;
}

void CBot::AimToIdeal()
{
     // UNDONE: Aim is too inhuman and isn't skill based
     
     if (m_iAimDelay > lastmillis)
          return;
     
     m_iAimDelay = lastmillis + RandomLong(10, 25); // UNDONE
     
	normalise(m_pMyEnt, m_pMyEnt->targetyaw);
    	if(m_pMyEnt->targetyaw>m_pMyEnt->yaw)             // slowly turn bot towards his target
    	{
        	m_pMyEnt->yaw += curtime*0.5f;
        	if(m_pMyEnt->targetyaw<m_pMyEnt->yaw) m_pMyEnt->yaw = m_pMyEnt->targetyaw;
    	}
    	else
    	{
        	m_pMyEnt->yaw -= curtime*0.5f;
		if(m_pMyEnt->targetyaw>m_pMyEnt->yaw) m_pMyEnt->yaw = m_pMyEnt->targetyaw;
    	}

        normalise(m_pMyEnt, m_pMyEnt->targetpitch);
    	if(m_pMyEnt->targetpitch>m_pMyEnt->pitch)             // slowly turn bot towards his target
    	{
        	m_pMyEnt->pitch += curtime*0.5f;
        	if(m_pMyEnt->targetpitch<m_pMyEnt->pitch) m_pMyEnt->pitch = m_pMyEnt->targetpitch;
    	}
    	else
    	{
        	m_pMyEnt->pitch -= curtime*0.5f;
		if(m_pMyEnt->targetpitch>m_pMyEnt->pitch) m_pMyEnt->pitch = m_pMyEnt->targetpitch;
    	}
}	

void CBot::BotPain(int damage, dynent *d)
{
     if(m_pMyEnt->state!=CS_ALIVE || editmode || intermission) return;
    //damageblend(damage);
//	demoblend(damage);
     int ad = damage*(m_pMyEnt->armourtype+1)*20/100;     // let armour absorb when possible
     if(ad>m_pMyEnt->armour) ad = m_pMyEnt->armour;
     m_pMyEnt->armour -= ad;
     damage -= ad;
     float droll = damage/0.5f;
     m_pMyEnt->roll += m_pMyEnt->roll>0 ? droll : (m_pMyEnt->roll<0 ? -droll : (rnd(2) ? droll : -droll));  // give player a kick depending on amount of damage
     if((m_pMyEnt->health -= damage)<=0)
     {
	if (player1 == d)
	{
             int frags;
	     if(isteam(player1->team, d->team))
             {
        	     frags = -1;
                     conoutf("you fragged a teammate (%s)", (int)m_pMyEnt->name);
             }
             else
             {
        	     frags = 1;
                     conoutf("you fragged %s", (int)m_pMyEnt->name);
             }
             addmsg(1, 2, SV_FRAGS, player1->frags += frags);             
             addmsg(1, 4, SV_BOTDIED, BotManager.GetBotIndex(m_pMyEnt), -1, false);
	}
        else if (d->monsterstate) conoutf("%s got killed by %s", (int)m_pMyEnt->name, (int)d->name);
	else
	{
             if (d == m_pMyEnt)
                  conoutf("%s suicided", (int)d->name);
                  
	     int KillerIndex = -1;
             
             if (d->bIsBot)
             {
                  KillerIndex = BotManager.GetBotIndex(d);
                  addmsg(1, 3, SV_BOTFRAGS, KillerIndex, ++d->frags);             
             }
	     else
	          loopv(players){ if (players[i] == d) { KillerIndex = i; break;} }
                  
             if(isteam(m_pMyEnt->team, d->team))
             {
                  conoutf("%s fragged his teammate (%s)", (int)d->name, (int)m_pMyEnt->name);
             }
             else
             {
                  conoutf("%s fragged %s", (int)d->name, (int)m_pMyEnt->name);
             }
               
             addmsg(1, 4, SV_BOTDIED, BotManager.GetBotIndex(m_pMyEnt), KillerIndex, d->bIsBot);
	}
	
        m_pMyEnt->lifesequence++;
        m_pMyEnt->deaths++;
        m_pMyEnt->attacking = false;
        m_pMyEnt->state = CS_DEAD;
        m_pMyEnt->pitch = 0;
        m_pMyEnt->roll = 60;
	//int PlayerIndex = -1;
	//loopv(players) if (players[i] == d) { PlayerIndex = i; break; }
        playsound(S_DIE1+rnd(2), &m_pMyEnt->o);
	//int msgtype = (d->bIsBot) ? SV_BOT2BOTDMG : SV_CLIENT2BOTDMG;
	//addmsg(1, 4, msgtype, GetBotIndex(m_pMyEnt), damage, PlayerIndex);
        spawnstate(m_pMyEnt);
        m_pMyEnt->lastaction = lastmillis;
    }
    else
    {
        playsound(S_PAIN6, &m_pMyEnt->o);
    }
}
	
void CBot::CheckItems()
{
    if(editmode) return;
    loopv(sents)
    {
        entity &e = ents[i];
        if(e.type==NOTUSED) continue;
        if(!sents[i].spawned && e.type!=TELEPORT && e.type!=JUMPPAD) continue;
        if(OUTBORD(e.x, e.y)) continue;
        vec v = { e.x, e.y, S(e.x, e.y)->floor+m_pMyEnt->eyeheight };
        vdist(dist, t, m_pMyEnt->o, v);
        if(dist<(e.type==TELEPORT ? 4 : 2.5))
	{
       		PickUp(i);
    	}
    }
}

void CBot::CheckQuad(int Time)
{
    if(m_pMyEnt->quadmillis && (m_pMyEnt->quadmillis -= Time)<0)
    {
        m_pMyEnt->quadmillis = 0;
        botplaysound(S_PUPOUT, m_pMyEnt);
        //conoutf("quad damage is over");
    }
}

void CBot::PickUp(int n)
{
    int np = 1;
    loopv(players) if(players[i]) np++;
    loopv(bots) if(bots[i]) np++;
    np = np<3 ? 4 : (np>4 ? 2 : 3);         // spawn times are dependent on number of players
    int ammo = np*2;
    switch(ents[n].type)
    {
        case I_SHELLS:  AddItem(n, m_pMyEnt->ammo[1], ammo); break;
        case I_BULLETS: AddItem(n, m_pMyEnt->ammo[2], ammo); break;
        case I_ROCKETS: AddItem(n, m_pMyEnt->ammo[3], ammo); break;
        case I_ROUNDS:  AddItem(n, m_pMyEnt->ammo[4], ammo); break;
        case I_HEALTH:  AddItem(n, m_pMyEnt->health,  np*5); break;
        case I_BOOST:   AddItem(n, m_pMyEnt->health,  60);   break;

        case I_GREENARMOUR:
            // (100h/100g only absorbs 166 damage)
            if(m_pMyEnt->armourtype==A_YELLOW && m_pMyEnt->armour>66) break;
            AddItem(n, m_pMyEnt->armour, 20);
            break;

        case I_YELLOWARMOUR:
            AddItem(n, m_pMyEnt->armour, 20);
            break;

        case I_QUAD:
            AddItem(n, m_pMyEnt->quadmillis, 60);
            break;
            
        case CARROT:
            ents[n].spawned = false;
            triggertime = lastmillis;
            trigger(ents[n].attr1, ents[n].attr2, false);  // needs to go over server for multiplayer
            break;

        case TELEPORT:
        {
            static int lastteleport = 0;
            if(lastmillis-lastteleport<500) break;
            lastteleport = lastmillis;
            teleport(n, m_pMyEnt);
            break;
        };
        
        case JUMPPAD:
        {
            if(lastmillis-m_iLastJumpPad<300) break;
            m_iLastJumpPad = lastmillis;
            vec v = { (int)(char)ents[n].attr3/10.0f, (int)(char)ents[n].attr2/10.0f, ents[n].attr1/10.0f };
			vadd(m_pMyEnt->vel, v);
            botplaysound(S_JUMPPAD, m_pMyEnt);
            break;
        };
    };
};

void CBot::AddItem(int i, int &v, int spawnsec)
{
       	if((i>=sents.length()) || (!sents[i].spawned))
		return;

        if(v>=itemstats[ents[i].type-I_SHELLS].max)  // don't pick up if not needed
             return;
             
	itemstat &is = itemstats[ents[i].type-I_SHELLS];
    	ents[i].spawned = false;
    	v += is.add;
    	if(v>is.max) v = is.max;
    	botplaysound(is.sound, m_pMyEnt);
	sents[i].spawned = false;
	sents[i].spawnsecs = spawnsec;
        
        addmsg(1, 4, SV_ITEMPICKUP, i, m_classicsp ? 100000 : spawnsec, false);
};

void CBot::SendBotInfo()
{
	if(lastmillis-m_iLastBotUpdate<40) return;    // don't update faster than 25fps
	m_iLastBotUpdate = lastmillis;

	int x = (int)(m_pMyEnt->o.x*DMF);
	int y = (int)(m_pMyEnt->o.y*DMF);
	int z = (int)(m_pMyEnt->o.z*DMF);
	int yaw = (int)(m_pMyEnt->yaw*DAF);
	int pitch = (int)(m_pMyEnt->pitch*DAF);
	int roll = (int)(m_pMyEnt->roll*DAF);
	int velx = (int)(m_pMyEnt->vel.x*DVF);
	int vely = (int)(m_pMyEnt->vel.y*DVF);
	int velz = (int)(m_pMyEnt->vel.z*DVF);
	// pack rest in 1 byte: strafe:2, move:2, onfloor:1, state:3
	int moveflags = (m_pMyEnt->strafe&3) | ((m_pMyEnt->move&3)<<2) | (((int)m_pMyEnt->onfloor)<<4) | ((editmode ? CS_EDITING : m_pMyEnt->state)<<5);
	
	//addmsg(1, 12, SV_BOTUPDATE, GetBotIndex(m_pMyEnt), x, y, z, yaw, pitch, roll, velx, vely, velz,
	//       moveflags);
	
//	       return;
	
    	ENetPacket *packet = enet_packet_create (NULL, MAXTRANS, 0);
    	uchar *start = packet->data;
    	uchar *p = start+2;
        
	putint(p, SV_BOTUPDATE);
        putint(p, BotManager.GetBotIndex(m_pMyEnt));
        putint(p, x);       // quantize coordinates to 1/16th of a cube, between 1 and 3 bytes
        putint(p, y);
        putint(p, z);
        putint(p, yaw);
        putint(p, pitch);
        putint(p, roll);
        putint(p, velx);     // quantize to 1/100, almost always 1 byte
        putint(p, vely);
        putint(p, velz);
        // pack rest in 1 byte: strafe:2, move:2, onfloor:1, state:3
        putint(p, moveflags);
	
        if(!m_bSendC2SInit)    // tell other clients who I am
        {
            packet->flags = ENET_PACKET_FLAG_RELIABLE;
            m_bSendC2SInit = true;
            putint(p, SV_ADDBOT);
	    putint(p, BotManager.GetBotIndex(m_pMyEnt));
            sendstring(m_pMyEnt->name, p);
            sendstring(m_pMyEnt->team, p);
            putint(p, m_pMyEnt->lifesequence);
        };
	
 
	*(ushort *)start = ENET_HOST_TO_NET_16(p-start);
    	enet_packet_resize(packet, p-start);
    	incomingdemodata(start, p-start, true);
    	if(clienthost) { enet_host_broadcast(clienthost, 0, packet); enet_host_flush(clienthost); }
    	else localclienttoserver(packet);
	
}

float CBot::GetDistance(const vec &o)
{
     vdist(flDist, vecto, m_pMyEnt->o, o);
     return flDist;
}

float CBot::GetDistance(const vec &v1, const vec &v2)
{
     vdist(flDist, vecto, v1, v2);
     return flDist;
}

bool CBot::SelectGun(int Gun)
{
     if (m_pMyEnt->ammo[Gun])
     {
          if (m_pMyEnt->gunselect != Gun)
               botplaysound(S_WEAPLOAD, m_pMyEnt);
               
          m_pMyEnt->gunselect = Gun;
          return true;
     }
     return false;
}

// Bot class end

// Bot manager class begin

void CBotManager::Init()
{
     if (!listenserv)
          return;

     m_bBotsShoot = true;
     LoadBotNamesFile();
     LoadBotTeamsFile();
     lsrand(time(NULL));
}
	
void CBotManager::Think()
{
	if (m_bInit)
	{
		Init();
		m_bInit = false;
	}
	
	// Let all bots 'think'
	loopv(bots)
	{
		if (!bots[i])
			continue;
		
		if (bots[i]->pBot)
			bots[i]->pBot->Think();
		else if (logbotinfo)
			conoutf("Error: pBot == NULL in bot ent\n");
	}
}

void CBotManager::LoadBotNamesFile()
{
	if (!listenserv)
		return;
		
	// Init bot names array first
	for (int i=0;i<100;i++)
		strcpy(m_szBotNames[i], "Bot");
	
	m_sBotNameCount = 0;
	
	// Load bot file
	char szNameFileName[256];
	MakeBotFileName("bot_names.txt", NULL, NULL, szNameFileName);
	FILE *fp = fopen(szNameFileName, "r");
	char szNameBuffer[256];
	int iIndex, iStrIndex;
	
	if (!fp)
	{
		conoutf("Warning: Couldn't load bot names file");
		return;
	}
	
	while ((m_sBotNameCount < 100) && (fgets(szNameBuffer, 80, fp) != NULL))
	{
		short length = strlen(szNameBuffer);

		if (szNameBuffer[length-1] == '\n')
		{
			szNameBuffer[length-1] = 0;  // remove '\n'
			length--;
		}

		iStrIndex = 0;
		while (iStrIndex < length)
		{
			if ((szNameBuffer[iStrIndex] < ' ') || (szNameBuffer[iStrIndex] > '~') ||
			    (szNameBuffer[iStrIndex] == '"'))
			{
				for (iIndex=iStrIndex; iIndex < length; iIndex++)
					szNameBuffer[iIndex] = szNameBuffer[iIndex+1];
			}
 
			iStrIndex++;
		}

		if (szNameBuffer[0] != 0)
		{
			strn0cpy(m_szBotNames[m_sBotNameCount], szNameBuffer, 16);
			m_sBotNameCount++;
		}
	}
	fclose(fp);
}
	
char *CBotManager::GetBotName()
{
	char *szOutput = NULL;
	TMultiChoice<char *> BotNameChoices;
	short ChoiceVal;
	
	for(int j=0;j<m_sBotNameCount;j++)
	{
		ChoiceVal = 50;
		
		loopv(players)
		{
			if (players[i] && (!stricmp(players[i]->name, m_szBotNames[j])))
				ChoiceVal -= 10;
		}
		
		loopv(bots)
		{
			if (bots[i] && (!stricmp(bots[i]->name, m_szBotNames[j])))
				ChoiceVal -= 10;
		}
		
		if (!stricmp(player1->name, m_szBotNames[j]))
			ChoiceVal -= 10;
			
		if (ChoiceVal <= 0)
			ChoiceVal = 1;
		
		BotNameChoices.Insert(m_szBotNames[j], ChoiceVal);
	}
	
	// Couldn't find a selection?
	if (!BotNameChoices.GetSelection(szOutput))
		szOutput = "Bot";
	
	return szOutput;
}
	
void CBotManager::LoadBotTeamsFile()
{
	if (!listenserv)
		return;
		
	// Init bot teams array first
	for (int i=0;i<20;i++)
		strcpy(m_szBotTeams[i], "b0ts");
	
	m_sBotTeamCount = 0;
	
	// Load bot file
	char szNameFileName[256];
	MakeBotFileName("bot_teams.txt", NULL, NULL, szNameFileName);
	FILE *fp = fopen(szNameFileName, "r");
	char szNameBuffer[256];
	int iIndex, iStrIndex;
	
	if (!fp)
	{
		conoutf("Warning: Couldn't load bot teams file");
		return;
	}
	
	while ((m_sBotTeamCount < 20) && (fgets(szNameBuffer, 80, fp) != NULL))
	{
		short length = strlen(szNameBuffer);

		if (szNameBuffer[length-1] == '\n')
		{
			szNameBuffer[length-1] = 0;  // remove '\n'
			length--;
		}

		iStrIndex = 0;
		while (iStrIndex < length)
		{
			if ((szNameBuffer[iStrIndex] < ' ') || (szNameBuffer[iStrIndex] > '~') ||
			    (szNameBuffer[iStrIndex] == '"'))
			{
				for (iIndex=iStrIndex; iIndex < length; iIndex++)
					szNameBuffer[iIndex] = szNameBuffer[iIndex+1];
			}
 
			iStrIndex++;
		}

		if (szNameBuffer[0] != 0)
		{
			strn0cpy(m_szBotTeams[m_sBotTeamCount], szNameBuffer, 5);
			m_sBotTeamCount++;
		}
	}
	fclose(fp);
}

char *CBotManager::GetBotTeam()
{
	char *szOutput = NULL;
	TMultiChoice<char *> BotTeamChoices;
	short ChoiceVal;
	
	for(int j=0;j<m_sBotTeamCount;j++)
	{
		ChoiceVal = 50;
		/* UNDONE?
		loopv(players)
		{
			if (players[i] && (!stricmp(players[i]->name, m_szBotNames[j])))
				ChoiceVal -= 10;
		}
		
		loopv(bots)
		{
			if (bots[i] && (!stricmp(bots[i]->name, m_szBotNames[j])))
				ChoiceVal -= 10;
		}
		
		if (!stricmp(player1->name, m_szBotNames[j]))
			ChoiceVal -= 10;
			
		if (ChoiceVal <= 0)
			ChoiceVmonsterclearal = 1;*/
		
		BotTeamChoices.Insert(m_szBotTeams[j], ChoiceVal);
	}
	
	// Couldn't find a selection?
	if (!BotTeamChoices.GetSelection(szOutput))
		szOutput = "b0t";
	
	return szOutput;
}

void CBotManager::RenderBots()
{
	loopv(bots)
	{
		if (bots[i]) 
			renderclient(bots[i], isteam(player1->team, bots[i]->team), "monster/ogro", false, 1.0f);
	}
}

void CBotManager::RemoveAllBots()
{
	loopv(bots)
	{
                //addmsg(1, 2, SV_BOTDIS, i);
                
		if (!bots[i])
			continue;
                        
		delete bots[i]->pBot;
            	zapdynent(bots[i]);
	}
        bots.setsize(0);
}

int CBotManager::GetBotIndex(dynent *m)
{
	loopv(bots)
	{
		if (!bots[i])
			continue;
	
		if (bots[i] == m)
			return i;
	}
	
	return -1;
}

void CBotManager::LetBotsUpdateStats()
{
	loopv(bots) if (bots[i] && bots[i]->pBot) bots[i]->pBot->m_bSendC2SInit = false;
}

void CBotManager::MakeBotFileName(const char *szFileName, const char *szDir1, const char *szDir2, char *szOutput)
{
	char *DirSeperator;

#ifndef __linux__
	DirSeperator = "\\";
	strcpy(szOutput, "bot\\");
#else
	DirSeperator = "/";
	strcpy(szOutput, "bot/");
#endif
	
	if (szDir1)
	{
		strcat(szOutput, szDir1);
		strcat(szOutput, DirSeperator);
	}
	
	if (szDir2)
	{
		strcat(szOutput, szDir2);
		strcat(szOutput, DirSeperator);
	}
	
	strcat(szOutput, szFileName);
}

// Bot manager class end

void addbot(char *arg1, char *arg2)
{
	// UNDONE: Needs to be decided who can and who can't add bots(voting?)
	if (listenserv)
	{
		conoutf("Creating bot...\n");
		CBot::CreateBot(arg1, arg2);
	}
	else
		conoutf("Only the host can create bots");
}

COMMAND(addbot, ARG_2STR);

void botsshoot(int Shoot)
{
     if (!listenserv) return;
     if (Shoot)
     {
          BotManager.SetBotsShoot(true);
          conoutf("Bots will shoot");
     }
     else
     {
          BotManager.SetBotsShoot(false);
          conoutf("Bots won't shoot");
     }
}

COMMAND(botsshoot, ARG_1INT);
          
void drawbeamtobots()
{
	loopv(bots)
	{
		particle_trail(1, 500, player1->o, bots[i]->o);
                //linestyle(2.0f, 0x80, 0x80, 0x80);
                //line(player1->o.x, player1->o.y, player1->o.z, bots[i]->o.x, bots[i]->o.y, bots[i]->o.z);
	}
}

COMMAND(drawbeamtobots, ARG_NONE);

void kickbot(const char *szName)
{
     if (!listenserv || !szName || !(*szName))
          return;
          
	int iBotInd = -1;
	loopv(bots)
	{
		if (!strcmp(bots[i]->name, szName))
		{
			iBotInd = i;
			break;
		}
	}
	
	if (iBotInd != -1)
	{
		addmsg(1, 2, SV_BOTDIS, iBotInd);
		
	    	conoutf("bot %s disconnected", (int)(bots[iBotInd]->name[0] ? bots[iBotInd]->name : "[incompatible client]"));
		delete bots[iBotInd]->pBot;
            	zapdynent(bots[iBotInd]);
		bots.remove(iBotInd);
	}
}

COMMAND(kickbot, ARG_1STR);

void togglegrap()
{
	if (SDL_WM_GrabInput(SDL_GRAB_QUERY) == SDL_GrabMode(0))
		SDL_WM_GrabInput(SDL_GRAB_ON);
	else
		SDL_WM_GrabInput(SDL_GrabMode(0));
}

COMMAND(togglegrap, ARG_NONE);

void testtraceline(void)
{
     vec from = player1->o;
     vec angles = {player1->pitch, player1->yaw, player1->roll};
     vec to, forward, right, up;
     
     //angles = WrapAngles(angles);
     AnglesToVectors(angles, forward, right, up);
     
     to = from;
     vmul(forward, 40);
     vadd(to, forward);
     
     vec end;
     TraceLine(from, to, end, player1, true);
     
     particle_trail(1, 2500, player1->o, end);
}

COMMAND(testtraceline, ARG_NONE);

    