//
// C++ Interface: bot
//
// Description: 
//
// Main bot header
//
//
// Author:  Rick <rickhelmus@gmail.com>, (C) 2004
//
//
//

#ifndef BOT_H
#define BOT_H

class CBot
{
	dynent *m_pMyEnt;
        int m_iLastBotUpdate;
        
        // Combat variabels
	float m_flShootDelay;
        float m_flChangeWeaponDelay;
        int m_iCombatNavTime;
	
	// Navigation variabeles
        int m_iCheckEnvDelay;
        int m_iPauseDelay;
        int m_iPauseTime;
        int m_iLastJumpPad;
        vec m_vPrevOrigin;
        float m_iStuckCheckDelay;
        bool m_bStuck;
        int m_iStuckTime;
        int m_iStrafeDir, m_iMoveDir;
        
        // Misc stuff
        entity *m_pTargetEnt;
        int m_iCheckTeleporterDelay;
        int m_iCheckJumppadsDelay;
        int m_iCheckEntsDelay;
        int m_iAimDelay;
        
        void AimToVec(const vec &o);
	void AimToIdeal(void);
	bool SelectGun(int Gun);
	void CheckItems(void);
	void CheckQuad(int Time);
	void PickUp(int n);
	void AddItem(int i, int &v, int spawnsec);
	void SendBotInfo(void);
        float GetDistance(const vec &o);
        float GetDistance(const vec &v1, const vec &v2);
        vec GetViewAngles(void) { vec temp = { m_pMyEnt->pitch, m_pMyEnt->yaw, m_pMyEnt->roll }; return temp; };
	
	// AI Functions
	bool FindEnemy(void);
	void ShootEnemy(void);
        void DoCombatNav(void);
	void HomeThroughMap(void);
        bool CheckStuck(void);
        bool CheckJump(void);
        bool CheckStrafe(void) { return false; /* UNDONE */};
        void CheckFOV(void);
        bool IsVisible(const vec &o);
        bool IsVisible(dynent *d) { return IsVisible(d->o); };
        float GetShootDelay(void);
        bool ChoosePreferredWeapon(void);
        entity *SearchForEnts(void);
        bool HeadToEnt(void);

public:
	bool m_bSendC2SInit;
	
	void Spawn(void);
	void Think(void);
	static dynent *CreateBot(const char *team, const char *name);
	void BotPain(int damage, dynent *d);
};

class CBotManager
{
	char m_szBotNames[100][16]; // Max 100 bot names with a length of 16 characters
	short m_sBotNameCount;
	char m_szBotTeams[20][5]; // Max 100 bot teams with a length of 5 characters
	short m_sBotTeamCount;        
	bool m_bInit;
        bool m_bBotsShoot;
	
	void LoadBotNamesFile(void);
        char *GetBotName(void);
        void LoadBotTeamsFile(void);
        char *GetBotTeam(void);
	void MakeBotFileName(const char *szFileName, const char *szDir1, const char *szDir2, char *szOutput);
	
	friend class CBot;
	
public:
	// Construction
	CBotManager(void) { m_bInit = true; };
	
	// Destruction
	~CBotManager(void) { RemoveAllBots(); };
	
	void Init(void);
	void Think(void);
	void RenderBots(void);
	void RemoveAllBots(void);
	int GetBotIndex(dynent *m);
	void LetBotsUpdateStats(void);
        bool BotsShoot(void) { return m_bBotsShoot; };
        void SetBotsShoot(bool bShoot) { m_bBotsShoot = bShoot; };
};

void addbot(char *arg1, char *arg2);
void botsshoot(int Shoot);
void drawbeamtobots(void);
void kickbot(const char *szName);
void togglegrap(void);

extern dvector bots;
extern CBotManager BotManager;
extern const vec g_vecZero;

#include "bot_util.h"
#endif
