//
// C++ Implementation: bot_ai
//
// Description: The AI part comes here(navigation, shooting etc)
//
//
// Author:  <rickhelmus@gmail.com>, (C) 2004
//
// Copyright: See COPYING file that comes with this distribution
//
//

// Code of CBot - Start

#include "cube.h"

struct itemstat { int add, max, sound; };

extern itemstat itemstats[];
extern vector<server_entity> sents;
extern vector<dynent*> monsters;

extern bool los(float lx, float ly, float lz, float bx, float by, float bz, vec &v);

bool logbotinfo = false;

bool CBot::FindEnemy(void)
{
     // UNDONE: Enemies are now only scored on their distance
     
     dynent *pNewEnemy = NULL, *d;
     float flDist, flNearestDist = 99999.9f;
     //TLinkedList<dynent *> EnemyChoices;
     short EnemyVal, BestEnemyVal = -100;
     
     // search for any monsters when DMSP mode
     if (m_dmsp)
     {
          loopv(monsters)
          {
               d = monsters[i]; // Handy shortcut
                        
               if (d->state != CS_ALIVE)
                    continue;
          
               // Check if the enemy is visible
               vec v_target = d->o;
               if(!IsVisible(d))
                    continue;
          
               flDist = GetDistance(d->o);
               EnemyVal = 1;
          
               if (flDist < flNearestDist)
               {
                    EnemyVal+=2;
                    flNearestDist = flDist;
               }
               
               if (EnemyVal > BestEnemyVal)
               {
                    pNewEnemy = d;
                    BestEnemyVal = EnemyVal;
               }
          }
     }
     else
     {
          // First loop through all players
          loopv(players)
          {
               d = players[i]; // Handy shortcut
          
               if (!d || isteam(d->team, m_pMyEnt->team) || (d->state != CS_ALIVE))
                    continue;
          
               // Check if the enemy is visible
               vec v_target = d->o;
               if(!IsVisible(d))
                    continue;
          
               flDist = GetDistance(d->o);
               EnemyVal = 1;
          
               if (flDist < flNearestDist)
               {
                    EnemyVal+=2;
                    flNearestDist = flDist;
               }
               
               if (EnemyVal > BestEnemyVal)
               {
                    pNewEnemy = d;
                    BestEnemyVal = EnemyVal;
               }
          }
          
          // Then loop through all bots
          loopv(bots)
          {
               d = bots[i]; // Handy shortcut
          
               if (d == m_pMyEnt)
                    continue;
               
               if (!d || isteam(d->team, m_pMyEnt->team) || (d->state != CS_ALIVE))
                    continue;
          
               // Check if the enemy is visible
               vec v_target = d->o;
               if(!IsVisible(d))
                    continue;
          
               flDist = GetDistance(d->o);
               EnemyVal = 1;
          
               if (flDist < flNearestDist)
               {
                    EnemyVal+=2;
                    flNearestDist = flDist;
               }
               
               if (EnemyVal > BestEnemyVal)
               {
                    pNewEnemy = d;
                    BestEnemyVal = EnemyVal;
               }
          }
     
          // Then examine the local player
          if (player1 && !isteam(player1->team, m_pMyEnt->team) && (player1->state == CS_ALIVE))
          {
               // Check if the enemy is visible
               vec v_target = player1->o;
               if(IsVisible(player1))
               {
                    flDist = GetDistance(player1->o);
                    EnemyVal = 1;
          
                    if (flDist < flNearestDist)
                    {
                         EnemyVal+=2;
                         flNearestDist = flDist;
                    }
               
                    if (EnemyVal > BestEnemyVal)
                    {
                         pNewEnemy = player1;
                         BestEnemyVal = EnemyVal;
                    }
               }
          }    
     }
          
     if (pNewEnemy)
     {
          m_pMyEnt->enemy = pNewEnemy;
          return true;
     }

     m_pMyEnt->enemy = NULL;     
     return false;
}

void CBot::ShootEnemy()
{
     if (!m_pMyEnt->enemy)
          return;
    
     // Aim to enemy
     AimToVec(m_pMyEnt->enemy->o);
     
     // Time to shoot?
     if (m_flShootDelay < lastmillis)
     {
          // Choose a preferred weapon first
          if (ChoosePreferredWeapon())
          {
               // Now shoot!
               m_pMyEnt->attacking = true;
	       shoot(m_pMyEnt, m_pMyEnt->enemy->o);
	       m_flShootDelay = lastmillis + GetShootDelay();
          }
     }
}

bool CBot::ChoosePreferredWeapon()
{
     TMultiChoice<int> WeaponChoices;
     double WeaponScore;
     float flDist = GetDistance(m_pMyEnt->enemy->o);
     
     if ((m_flChangeWeaponDelay > lastmillis) && (m_pMyEnt->ammo[m_pMyEnt->gunselect]))
          return true;
            
     // Rate fist
     WeaponScore = 10;
     
     if (flDist > 3)
          WeaponScore -= (flDist * 2);
     else
          WeaponScore *= 2;
     
     if (m_pMyEnt->ammo[GUN_FIST] == 0)
          WeaponScore = 0;
          
     WeaponChoices.Insert(GUN_FIST, (int)WeaponScore);
     
     // Rate Shotgun
     WeaponScore = 10;
     
     if (m_pMyEnt->ammo[GUN_SG])
     {
          if (m_pMyEnt->ammo[GUN_SG] > 15)
               WeaponScore *= 2;
          else if (m_pMyEnt->ammo[GUN_SG] > 10)
               WeaponScore *= 1.5;
          else if (m_pMyEnt->ammo[GUN_SG] > 8)
               WeaponScore *= 1.2;
          else if (m_pMyEnt->ammo[GUN_SG] <= 3)
               WeaponScore *= 0.75;
     }
     else
          WeaponScore = 0;
     
     if (flDist > 15)
          WeaponScore *= 0.5;
     else if (flDist > 10)
          WeaponScore *= 0.75;
     else if (flDist > 8);
     else if (flDist > 6)
          WeaponScore *= 1.2;
     else
          WeaponScore *= 1.5;  
     
     WeaponChoices.Insert(GUN_SG, (int)WeaponScore);
     
     
     // Rate Chaingun
     WeaponScore = 10;
     
     if (m_pMyEnt->ammo[GUN_CG])
     {
          if (m_pMyEnt->ammo[GUN_CG] > 20)
               WeaponScore *= 2;
          else if (m_pMyEnt->ammo[GUN_CG] > 15)
               WeaponScore *= 1.5;
          else if (m_pMyEnt->ammo[GUN_CG] > 10)
               WeaponScore *= 1.2;
          else if (m_pMyEnt->ammo[GUN_CG] < 3)
               WeaponScore *= 0.75;
     }
     else
          WeaponScore = 0;
        
     WeaponChoices.Insert(GUN_CG, (int)WeaponScore);
     
     
     // Rate Rocket Launcher
     WeaponScore = 10;
     
     if (m_pMyEnt->ammo[GUN_RL])
     {
          if (m_pMyEnt->ammo[GUN_RL] > 10)
               WeaponScore *= 2;
          else if (m_pMyEnt->ammo[GUN_RL] > 5)
               WeaponScore *= 1.5;
          else if (m_pMyEnt->ammo[GUN_RL] < 2)
               WeaponScore *= 0.75;
     }
     else
          WeaponScore = 0;
     
     if (flDist > 25)
          WeaponScore *= 0.5;
     else if (flDist > 10);
     else if (flDist >= 8)
          WeaponScore *= 0.8;
     else if (flDist >= 6)
          WeaponScore *= 0.6;
     else
          WeaponScore *= 0.25;  
     
     WeaponChoices.Insert(GUN_RL, (int)WeaponScore);
             
     
     // Rate rifle
     WeaponScore = 10;
     
     if (m_pMyEnt->ammo[GUN_RIFLE])
     {
          if (m_pMyEnt->ammo[GUN_RIFLE] > 10)
               WeaponScore *= 2;
          else if (m_pMyEnt->ammo[GUN_RIFLE] > 5)
               WeaponScore *= 1.5;
          else if (m_pMyEnt->ammo[GUN_RIFLE] < 2)
               WeaponScore *= 0.75;
     }
     else
          WeaponScore = 0;
     
     if (flDist > 15)
          WeaponScore *= 1.5;
     else if (flDist > 10)
          WeaponScore *= 1.25;
     else if (flDist <= 6)
          WeaponScore *= 0.75;
     
     WeaponChoices.Insert(GUN_RIFLE, (int)WeaponScore);
     
     int WeaponSelect;
     if (WeaponChoices.GetSelection(WeaponSelect))
     {
          m_flChangeWeaponDelay = lastmillis + RandomLong(2000, 8000);
          return SelectGun(WeaponSelect);
     }
     
     return false;
}
     
float CBot::GetShootDelay()
{
     // UNDONE: Needs to be skill based
     //return RandomLong(1500, 2350);
     if ((m_pMyEnt->gunselect == GUN_FIST) || (m_pMyEnt->gunselect == GUN_CG))
          return m_pMyEnt->gunwait;
          
     return m_pMyEnt->gunwait + RandomLong(100, 250);
}

void CBot::HomeThroughMap()
{
     // UNDONE
     
     if (m_pMyEnt->enemy) // Combat navigation
     {
          if (!CheckJump())
               DoCombatNav();
     }
     else if (HeadToEnt()) // Heading to an interesting entity(ammo, armour etc)
     {
          if (!CheckJump() && CheckStuck())
               m_iCheckEntsDelay = lastmillis + RandomLong(1000, 2000); // Don't check for ents a while when stuck
     }
     else // Normal navigation
     {
          // Make sure the bot looks straight forward and not up or down
          m_pMyEnt->pitch = 0;
          
          // Is the bot taking a break?
          if (m_iPauseTime > lastmillis)
               m_pMyEnt->move = 0;
          else if (m_iPauseTime > 0)
          {
               m_iStuckCheckDelay = lastmillis + 250;
               m_iPauseTime = 0;
               m_iPauseDelay = lastmillis + RandomLong(8500, 15000); // UNDONE: Should be skill dependant
          }
          else if (m_iPauseDelay < lastmillis) // Time to pause?
          {
               m_iPauseTime = lastmillis + RandomLong(1250, 2500); // UNDONE: Should be skill dependant
          }
          else // Regular navigation, no pause
          {    
               // Time to check the environment?
               if (m_iCheckEnvDelay < lastmillis)
               {
                    // Check for stuck and strafe
                    if (!CheckStuck() && !CheckStrafe())
                    {
                         // Only do this when the bot isn't stuck or had to strafe
                         
                         // Check field of view (FOV)
                         CheckFOV();
                    }
               }
               
               m_pMyEnt->move = 1;
          }         
     }
}

void CBot::DoCombatNav()
{
     if (m_iCombatNavTime > lastmillis)
     {
          m_pMyEnt->move = m_iMoveDir;
          m_pMyEnt->strafe = m_iStrafeDir;
          return;
     }
     else if (m_pMyEnt->gunselect == GUN_FIST)
          return; // Simply walk towards enemy if 'using' fist
          
     float flDist = GetDistance(m_pMyEnt->enemy->o);
     
     if (flDist > 6)
          m_pMyEnt->move = m_iMoveDir = 1; // Run forward when not close
     else
          m_pMyEnt->move = m_iMoveDir = -1; // Run backwards when fairly close to enemy
     
     vec src, forward, right, up, end, dest, MyAngles = GetViewAngles(), o = m_pMyEnt->o;
     
     // Is it furthest or farthest? bleh
     float flFurthestDist = 0;
     int bestdir = -1, dir = 0;
     bool moveback = (m_pMyEnt->move == -1);
     
     for(int j=-45;j<=45;j+=45)
     {
          src = MyAngles;
          src.y = WrapYZAngle(src.y + j);
          
          // If we're moving backwards, trace backwards
          if (moveback)
               src.y = WrapYZAngle(src.y + 180);
          
          AnglesToVectors(src, forward, right, up);
          
          dest = o;
          vmul(forward, 40);
          vadd(dest, forward);
          
          TraceLine(o, dest, end, m_pMyEnt, false);
          
          //particle_trail(1, 500, origin, end);
          flDist = GetDistance(end);
          
          if (flFurthestDist < flDist)
          {
               flFurthestDist = flDist;
               bestdir = dir;
          }
          dir++;
     }
     
     switch(bestdir)
     {
     case 0:
          if (moveback)
               m_pMyEnt->strafe = m_iStrafeDir = -1; // Strafe right
          else
               m_pMyEnt->strafe = m_iStrafeDir = 1; // Strafe left
          
          m_iCombatNavTime = lastmillis + 500;
          break;
     case 1:
          m_pMyEnt->strafe = m_iStrafeDir = 0; // Don't strafe
          m_iCombatNavTime = lastmillis + 500;
          break;
     case 2:
          if (moveback)
               m_pMyEnt->strafe = m_iStrafeDir = 1; // Strafe left
          else
               m_pMyEnt->strafe = m_iStrafeDir = -1; // Strafe right
               
          m_iCombatNavTime = lastmillis + 500;
          break;
     }               
}

bool CBot::CheckStuck()
{
     if (m_iStuckCheckDelay >= lastmillis)
          return true; // Just walk forward
          
     bool IsStuck = false;
     
     vec CurPos = m_pMyEnt->o, PrevPos = m_vPrevOrigin;
     CurPos.z = PrevPos.z = 0;
     // Did the bot hardly move the last frame?
     if (GetDistance(CurPos, PrevPos) < 0.05)
     {
          if (m_bStuck)
          {
               if (m_iStuckTime < lastmillis)
                    IsStuck = true;
          }
          else
          {
               m_bStuck = true;
               m_iStuckTime = lastmillis + 1000;
          }
     }
     else
     {
          m_bStuck = false;
          m_iStuckTime = 0;
     }
     
     if (IsStuck)          
     {
          if (logbotinfo)
          {
               char msg[64];
               sprintf(msg, "stuck (%f)", GetDistance(m_vPrevOrigin));
               conoutf(msg);
          }
          
          m_bStuck = false;
          m_iStuckTime = 0;
          
          // Crap bot is stuck, lets just try some random things
                        
          // Check if the bot can turn around
          vec src = GetViewAngles();
          src.x = 0;
          vec forward, left, right, up, end, dest;
          
          AnglesToVectors(src, forward, right, up);
          
          // Check the left side...
          left.x = -right.x; left.y = -right.y; left.z = -right.z;
          dest = m_pMyEnt->o;
          vmul(left, 3);
          vadd(dest, left);
          
          TraceLine(m_pMyEnt->o, dest, end, m_pMyEnt, true);
          //particle_trail(1, 500, m_pMyEnt->o, end);
          
          if (GetDistance(end) >= 3)
          {
               // Bot can turn left, do so
               m_pMyEnt->targetyaw = WrapYZAngle(m_pMyEnt->targetyaw - 90);
               m_iStuckCheckDelay = lastmillis + 500;
               return true;
          }
          
          // Check the right side...     
          dest = m_pMyEnt->o;
          vmul(right, 3);
          vadd(dest, right);
          
          TraceLine(m_pMyEnt->o, dest, end, m_pMyEnt, true);
          //particle_trail(1, 500, m_pMyEnt->o, end);
          
          if (GetDistance(end) >= 3)
          {
               // Bot can turn right, do so
               m_pMyEnt->targetyaw = WrapYZAngle(m_pMyEnt->targetyaw + 90);
               m_iStuckCheckDelay = lastmillis + 500;
               return true;
          }
          
          // Check if bot can turn 180 degrees
          dest = m_pMyEnt->o;
          vmul(forward, 3);
          vsub(dest, right);
          
          TraceLine(m_pMyEnt->o, dest, end, m_pMyEnt, true);
          //particle_trail(1, 500, m_pMyEnt->o, end);
          
          if (GetDistance(end) >= 3)
          {
               // Bot can turn around, do so
               m_pMyEnt->targetyaw = WrapYZAngle(m_pMyEnt->targetyaw + 180);
               m_iStuckCheckDelay = lastmillis + 500;
               return true;
          }
          
          // Bleh bot couldn't turn, lets just randomly jump :|
          
          m_pMyEnt->jumpnext = true;
          return true;
     }
     
     return false;
}

// Check if a near wall is blocking and we can jump over it
bool CBot::CheckJump()
{
     vec src, MyAngles = GetViewAngles(), forward, up, right, dest, end, start = m_pMyEnt->o;

     // Trace a line to see if something blocks our way on eyeheight
     AnglesToVectors(MyAngles, forward, right, up);
     dest = start;
     vmul(forward, 3);
     vadd(dest, forward);
     TraceLine(start, dest, end, m_pMyEnt, false);
     
     float flEyeHighDist = GetDistance(end);
     
     // Something blocks at eye hight?
     if (flEyeHighDist < 3)
     {
          // Check if the bot can jump over it
          src = MyAngles;
          src.x = 0;
     
          AnglesToVectors(src, forward, right, up);
     
          start.z += 1.5f;
          dest = start;
          vmul(forward, 6);
          vadd(dest, forward);
          
          TraceLine(start, dest, end, m_pMyEnt, false);
          //particle_trail(1, 500, start, end);
     
          if (GetDistance(start, end) >= 6)
          {
               // Jump
               if (logbotinfo) conoutf("High wall");
               m_pMyEnt->jumpnext = true;
               return true;
          }
     }
     else
     {
          // Check if something is blocking at feet height, so the bot can jump over it
          src = MyAngles;
          src.x = 0;
     
          AnglesToVectors(src, forward, right, up);
     
          start.z -= 1.7f;
          dest = start;
          vmul(forward, 4);
          vadd(dest, forward);
          
          TraceLine(start, dest, end, m_pMyEnt, false);
     
          // Trace was blocked?
          float flTraceDist = GetDistance(start, end);
          if (flTraceDist < 3)
          {
               //particle_trail(1, 500, start, end);
          
               // Jump
               if (logbotinfo) conoutf("Low wall");
               m_pMyEnt->jumpnext = true;
               return true;
          }
     }
     
     return false; // Bot didn't had to jump(or couldn't)
}
     
void CBot::CheckFOV()
{
     m_iCheckEnvDelay = lastmillis + RandomLong(250, 750);
     vec MyAngles = GetViewAngles();
     vec src, forward, right, up, dest, end, best = {0,0,0};
     vec origin = m_pMyEnt->o;
     float flDist, flFurthestDist = 0;
     bool WallLeft = false;
     
     //origin.z -= 1.5; // Slightly under eye level
             
     // Scan 90 degrees FOV
     for(int angle=-45;angle<=45;angle+=5)
     {
          src = MyAngles;
          src.y = WrapYZAngle(src.y + angle);
          
          AnglesToVectors(src, forward, right, up);
          
          dest = origin;
          vmul(forward, 40);
          vadd(dest, forward);
          
          TraceLine(origin, dest, end, m_pMyEnt, false);
          
          //particle_trail(1, 500, origin, end);
          flDist = GetDistance(end);
          
          if (flFurthestDist < flDist)
          {
               flFurthestDist = flDist;
               best = end;
          }
     }
     
     if (best.x && best.y && best.z)
     {
          AimToVec(best);
          // Update MyAngles, since their (going to be) change(d)
          MyAngles.x = m_pMyEnt->targetpitch;
          MyAngles.y = m_pMyEnt->targetyaw;
     }
     
     float flNearestHitDist = GetDistance(best);
     
     // Check if a near wall is blocking and we can jump over it
     if (flNearestHitDist < 4)
     {
          // Check if the bot can jump over it
          src = MyAngles;
          src.x = 0;
     
          AnglesToVectors(src, forward, right, up);
     
          vec start = origin;
          start.z += 1.5;
          dest = start;
          vmul(forward, 6);
          vadd(dest, forward);
          
          TraceLine(start, dest, end, m_pMyEnt, false);
          //particle_trail(1, 500, start, end);
     
          if (GetDistance(start, end) >= 6)
          {
               // Jump
               if (logbotinfo) conoutf("High wall");
               m_pMyEnt->jumpnext = true;
               return;
          }
     }
     else
     {
          // Check if something is blocking below us, so the bot can jump over it
          src = MyAngles;
          src.x = 0;
     
          AnglesToVectors(src, forward, right, up);
     
          vec start = origin;
          start.z -= 1.7f;
          dest = start;
          vmul(forward, 4);
          vadd(dest, forward);
          
          TraceLine(start, dest, end, m_pMyEnt, false);
     
          // Trace was blocked?
          float flTraceDist = GetDistance(start, end);
          if (flTraceDist < 4)
          {
               //particle_trail(1, 500, start, end);
          
               // Jump
               if (logbotinfo) conoutf("Low wall");
               m_pMyEnt->jumpnext = true;
               return;
          }
     }
     
     // Is the bot about to head a corner?
     src = MyAngles;
     src.y -= 45;
     AnglesToVectors(src, forward, right, up);
     
     dest = origin;
     vmul(forward, 5);
     vadd(dest, forward);
          
     TraceLine(origin, dest, end, m_pMyEnt, false);
     
     WallLeft = (GetDistance(end) < 7);
     
     src = MyAngles;
     src.y += 45;
     AnglesToVectors(src, forward, right, up);
     
     dest = origin;
     vmul(forward, 7);
     vadd(dest, forward);
          
     TraceLine(origin, dest, end, m_pMyEnt, false);
     
     if (WallLeft && (GetDistance(end) < 7))
     {
          // We're about to hit a corner, turn away
          if (logbotinfo) conoutf("Corner");
          m_pMyEnt->targetyaw = WrapYZAngle(m_pMyEnt->yaw + 180);
          m_iCheckEnvDelay = lastmillis + RandomLong(750, 1500);
          m_iPauseDelay = max(m_iPauseDelay + 1250, lastmillis + 1250);
          return;
     }     
}

entity *CBot::SearchForEnts(void)
{
     float flNearestDist = 9999, flDist;
     entity *pNewTargetEnt = NULL;
     bool CheckTeleporters = (m_iCheckTeleporterDelay < lastmillis);
     bool CheckJumppads = (m_iCheckJumppadsDelay < lastmillis);    
     
     loopv(ents)
     {
          entity &e = ents[i];
          vec o = {e.x, e.y, e.z};
     
          if ((e.type == TELEPORT) && !CheckTeleporters)
               continue;

          if ((e.type == JUMPPAD) && !CheckJumppads)
               continue;
          
          if ((!ents[i].spawned) && (e.type != TELEPORT) && (e.type != JUMPPAD)) continue;
          if (OUTBORD(e.x, e.y)) continue;
          
          if (e.z > (m_pMyEnt->o.z + 1)) continue;
          
          bool bInteresting = false;
          switch(e.type)
          {
          case TELEPORT:
          case JUMPPAD:
               bInteresting = true;
               break;
          case I_SHELLS:
               bInteresting = (m_pMyEnt->ammo[1]<itemstats[e.type-I_SHELLS].max);
               break;
          case I_BULLETS:
               bInteresting = (m_pMyEnt->ammo[2]<itemstats[e.type-I_SHELLS].max);
               break;
          case I_ROCKETS:
               bInteresting = (m_pMyEnt->ammo[3]<itemstats[e.type-I_SHELLS].max);
               break;
          case I_ROUNDS:
               bInteresting = (m_pMyEnt->ammo[4]<itemstats[e.type-I_SHELLS].max);
               break;              
          case I_HEALTH:
          case I_BOOST:
               bInteresting = (m_pMyEnt->health<itemstats[e.type-I_SHELLS].max);
               break;
          case I_GREENARMOUR:
               bInteresting = ((m_pMyEnt->armour<itemstats[e.type-I_SHELLS].max) &&
                               (m_pMyEnt->armourtype!=A_YELLOW || m_pMyEnt->armour<=66));
               break;
          case I_YELLOWARMOUR:
               bInteresting = (m_pMyEnt->armour<itemstats[e.type-I_SHELLS].max);
               break;
          case I_QUAD:
               bInteresting = (m_pMyEnt->quadmillis<itemstats[e.type-I_SHELLS].max);
               break;
          }
              
          if (!bInteresting)
              continue; // Not an interesting item, skip
              
          flDist = GetDistance(o);
                              
          if ((flDist < flNearestDist) && IsVisible(o))
          {
               flNearestDist = flDist;
               pNewTargetEnt = &ents[i];
          }
     }
     
     if (pNewTargetEnt)
     {
          if (pNewTargetEnt->type == JUMPPAD) m_iCheckJumppadsDelay = lastmillis + 3500;
          else if (pNewTargetEnt->type == TELEPORT) m_iCheckTeleporterDelay = lastmillis + 5000;
     }
          
     return pNewTargetEnt;
}
          
bool CBot::HeadToEnt()
{
     if (m_iCheckEntsDelay > lastmillis)
          return false;
          
     if (!m_pTargetEnt)
          m_pTargetEnt = SearchForEnts();
          
     if (m_pTargetEnt)
     {
          vec o = {m_pTargetEnt->x, m_pTargetEnt->y, m_pTargetEnt->z};
          if (IsVisible(o) && (m_pTargetEnt->spawned || (m_pTargetEnt->type == TELEPORT) || 
               (m_pTargetEnt->type == JUMPPAD)))
          {
               AimToVec(o);
               return true;
          }
          else
               m_pTargetEnt = NULL;
     }
     
     return false;
}

bool CBot::IsVisible(const vec &o)
{
     vec end;
     TraceLine(m_pMyEnt->o, o, end, m_pMyEnt, false);
     return (GetDistance(end) >= GetDistance(o));
     //vec v = m_pMyEnt->o;
     //return los(m_pMyEnt->o.x, m_pMyEnt->o.y, m_pMyEnt->o.z, o.x, o.y, o.z, v);
}
    
// Code of CBot - End
